unit Drak3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  async32;

type
  TDrak3 = class(TCustomComm32)
  private
    { Private declarations }
    FAddress:char;
    procedure WriteCom(s:string);
    function ReadCom:string;
    function GetAddress:byte;
    procedure SetAddress(Address:byte);
    procedure SetBaud(baud:word);
    function GetBaud:word;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    function Mer(vstup:byte):string;
       //vstup - udava, ktery vstup se ma merit; rozsah je [1..3]
       //vraci zmerenou hodnotu jako string dlouhy 5 bytu
       //pokud vrati otaznik '?', doslo k chybe
    function Test:boolean;
      //vraci funkcnost modulu, je treba nastavit port, rychlost a adresu
    function ZapisKonfiguraci(adresa:byte;rychlost:word):boolean;
      //zapise novou adresu a rychlost

  published
    { Published declarations }
    property DeviceName;  {jmeno portu zadane jako string napr. 'COM1'}
    property Baud:word read GetBaud write SetBaud default 9600;    {komunikacni rychlost}
    property Address:byte Read GetAddress Write SetAddress default 1; {Adresa modulu DRAK3 v rozsahu 0-15}
  end;

procedure Register;

implementation

constructor TDrak3.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  FAddress:='1';
end;

destructor TDrak3.Destroy;
begin
     inherited Destroy;
end;
function TimeMs:comp;
begin
     result:=TimeStampToMsecs(DateTimeToTimeStamp(time));
end;

procedure TDrak3.WriteCom(s:string);
var
   pch:array [1..255] of char;
   b:byte;
begin
    for b:=1 to length(s) do pch[b]:=s[b];
    write(pch,length(s));
end;

function TDrak3.ReadCom:string;
const
     WaitForReply = 100; {doba odezvy Draka v ms}
var
   ch:char;
   Time:comp;
   b,w,kolik,oldIQC,IQC:word;
   s:string;
begin
    s:='';
    repeat
    until OutQueCount<1;
    b:=OutQueCount;
   if b=0 then {zabranuje soucasnemu vysilani i prijimani}
    begin
     Time:=TimeMs;
     repeat {ceka na odpoved dobu danou konstantou WaitForReply}
     until (InQueCount>0) or (Time+WaitForReply<TimeMs);
     repeat
       OldIQC:=InQueCount;
       Time:=TimeMs;
       repeat
       until (Time+10<TimeMs);
     until (oldIQC=InQueCount);
     IQC:=InQueCount;
     if IQC<250 then kolik:=IQC
                else kolik:=250;
     for w:=1 to kolik do
     begin
       Read(ch,1);
       s:=s+ch;
     end;
     SetLength(s,kolik);
     Result:=s;
    end
end;

function TDrak3.GetAddress:byte;
const
     asc='0123456789ABCDEF';
begin
     Result:=pos(FAddress,asc)-1;
end;

procedure TDrak3.SetAddress(Address:byte);
const
     asc='0123456789ABCDEF';
begin
     if Address in [0..15] then FAddress:=copy(asc,address+1,1)[1];
end;

procedure TDrak3.SetBaud(baud:word);
begin
     case baud of
       1200:BaudRate:=cbr1200;
       2400:BaudRate:=cbr2400;
       4800:BaudRate:=cbr4800;
       9600:BaudRate:=cbr9600;
       end;
end;

function TDrak3.GetBaud:word;
begin
     Result:=9600;
     case BaudRate of
       cbr1200:Result:=1200;
       cbr2400:Result:=2400;
       cbr4800:Result:=4800;
       cbr9600:Result:=9600;
       end;
end;

function TDrak3.Test:boolean;
var
   s:string;
begin
     WriteCom('*'+FAddress+'T');
     s:=ReadCom;
     if pos('OK',s)>0 then Result:=true
                      else Result:=false;
end;

function TDrak3.Mer(vstup:byte):string;
const
     asc='0123456789ABCDEF';
     CR=#13;
var
   vstupCh:string[1];
   s:string[20];
   ChkSum,CRC:byte;
begin
     crc:=1;ChkSum:=2;
     if vstup in [1..3] then
     begin
      vstupCh:=copy(asc,vstup+1,1);
      PurgeIn;PurgeOut;
      WriteCom('*'+FAddress+'M'+vstupCh+CR);
      s:=ReadCom;
      if s<>'' then begin
                      ChkSum:=byte(ord(s[1])+ord(s[2])+ord(s[3])+ord(s[4])+ord(s[5]));
                      if not ((pos(s[6],asc)=0) or (pos(s[7],asc)=0)) then CRC:=((pos(s[6],asc)-1)*16)+(pos(s[7],asc)-1);
                    end;  
      if (crc<>Chksum) or (s='') then Result:='?'
                                 else Result:=copy(s,1,5);
     end
      else result:='?';
end;

function TDrak3.ZapisKonfiguraci(adresa:byte;rychlost:word):boolean;
const
     asc='0123456789ABCDEF';
     speed='12.4...9';
var
   s:string;
begin
     Result:=false;
     if (adresa in [0..15]) and ((rychlost div 1200) in [1,2,4,8]) then
    begin
     PurgeIn;PurgeOut;
     WriteCom('*'+FAddress+'P');
     ReadCom;
     WriteCom('*'+FAddress+'X'+copy(asc,adresa+1,1)+copy(speed,rychlost div 1200,1));
     s:=readCom;
     if pos(copy(asc,adresa-1,1)+copy(speed,rychlost div 1200,1),s)>0 then Result:=true
                                                                      else Result:=false;
     if Result then begin
                         SetAddress(adresa);
                         case rychlost of
                           1200:BaudRate:=cbr1200;
                           2400:BaudRate:=cbr2400;
                           4800:BaudRate:=cbr4800;
                           9600:BaudRate:=cbr9600;
                         end;
                    end;
     Close;
     Open;
    end;
end;

procedure Register;
begin
  RegisterComponents('Drak', [TDrak3]);
end;

end.
